const ko = require("knockout");

const {Step} = require("cattura-ui-library/src/lib/ui/wizard");

function makeStep (options)
{
    const formatMoment = options.momentFormatter || (moment => moment.toString());
    const dateTime     = options.dateTime;
    
    const dateTimeFormatted = ko.computed(() => {
        const dateTimeUnwrapped = dateTime();
        if (!dateTimeUnwrapped)
        {
            return "";
        }

        return formatMoment(dateTimeUnwrapped);
    });

    return Step({
        step: 5,
        dateTimeFormatted: dateTimeFormatted
    });
}

module.exports = makeStep;

