(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.schedulerPluginExtension = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

},{}],2:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const moment = require("moment");

const Dialog = require("cattura-ui-library/src/lib/ui/dialog");
const {Wizard} = require("cattura-ui-library/src/lib/ui/wizard");
const ScheduledEvent = require("cattura-ui-library/src/lib/scheduledEvent");
const MediaPackage = require("cattura-ui-library/src/lib/mediaPackage");

const DEFAULT_OPTIONS = {
    recorders: [],
    momentFormatter: moment => moment.toString(),
    momentGenerator: moment,
    relativizeStoragePath: path => path,
    previewRecording: () => {},
    recorder: ko.observable()
};

function makeDialog (options)
{
    options = _({})
        .extend(DEFAULT_OPTIONS)
        .extend(options)
        .value();
    
    if (ko.isObservable(options.recorder))
    {
        options.recorder((ko.unwrap(options.recorders) || [])[0]);
    }
    
    const relativizeStoragePath = options.relativizeStoragePath;
    const previewRecording      = options.previewRecording;
    
    const intro = require("./step-0-intro");
    const details = require("./step-1-details")(options);
    const datetime = require("./step-2-date-time")({
        momentGenerator: options.momentGenerator
    });
    const assets = require("./step-3-assets")(options);
    const summary = require("./step-4-summary")({
        momentFormatter: options.momentFormatter,
        dateTime: datetime.dateTime
    });

    const {title, template, tags, appendDateToTitle} = details;
    const {dateTime, duration, recur, recurrenceStartDateTime, recurrenceEndDate, days} = datetime;

    /* jshint -W079 */
    const confirm = require("cattura-ui-library/src/modals/confirm");

    let isReadOnly = ko.observable(false);
    let readOnlyReason = ko.observable("");
    let eventId = ko.observable();
    let eventGroupId = ko.observable();
    
    // Raw event object returned from the API.
    // This doesn't exist for new events and does not change when the
    // event is modified. It's intended for external scheduler plugins
    // to be able to pull and display additional data associated to an
    // external event.
    let eventObject = ko.observable();

    // The recorder the currently loaded event belongs to.
    // For multi-recorder instances (i.e. Command Center).
    // All operations done on existing events (update, delete) use this instead
    // of the user-selected recorder observable.
    // This is null for new events.
    let parentRecorder = ko.observable();

    // For external events
    let externalSchedulerId = ko.observable();
    let externalSchedulerName = ko.observable();
    let externalEventUrl = ko.observable();
    const externalScheduler = ko.computed(() => {
        if (!externalSchedulerId())
        {
            return null;
        }
        
        return _(ko.unwrap((parentRecorder() || {}).externalSchedulers) || [])
            .find(plugin => plugin.id === externalSchedulerId());
    });
    
    // For completed recordings
    let mediaPackage = ko.observable();

    // For failed recordings
    let errorMessage = ko.observable();
    
    function extendMediaPackage (mediaPackage)
    {
        if (relativizeStoragePath)
        {
            mediaPackage.root = relativizeStoragePath(mediaPackage.root);
        }
        
        return mediaPackage;
    }

    function determineReadOnlyReason (event)
    {
        readOnlyReason("unknown");

        if (event.sourceName)
        {
            readOnlyReason("external");
            externalSchedulerId(event.sourceID);
            externalSchedulerName(event.sourceName);
            externalEventUrl(event.externalEventURL);
        }

        if (event.mediaPackageID)
        {
            readOnlyReason("complete");
            parentRecorder().apiv1.capture.getMediaPackage({
                id: event.mediaPackageID
            }).then(result => {
                mediaPackage(extendMediaPackage(new MediaPackage(result)));
            });
        }

        if (event.failedToStart())
        {
            readOnlyReason("failedToStart");
        }

        if (event.errorMessage)
        {
            readOnlyReason("error");
            errorMessage(event.errorMessage);
        }    
    }

    return Dialog({
        open (event, recorder)
        {
            this.reset();
            if (event && "startTime" in event)
            {
                eventId(event.id);
                eventObject(event);

                // Determine if this event belongs to a recorder
                // (if we're in multi-recorder mode)
                if (event.recorder)
                {
                    recorder = event.recorder;
                }
                else if (event.unit)
                {
                    recorder = event.unit;
                }
            }
            else
            {
                // Recorder passed in as first argument?
                if (!recorder && event && event.templates)
                {
                    recorder = event;
                }
                
                event = null;
            }
            
            // Map passed-in recorder object to an object we know about.
            // This object was either passed in as an argument or attached 
            // to the event object.
            const recorders = ko.unwrap(options.recorders) || [];
            if (recorder)
            {
                recorder = _(recorders).find(recorderObject => recorder === recorderObject ||
                                             recorderObject.id === recorder.id ||
                                             recorderObject.url === recorder.url);
            }
            // It is an error to pass in events with no associated recorders in multi-recorder mode.
            else if (recorders.length > 1)
            {
                throw new Error("addEditEvent modal is in multi-recorder mode but no recorder is associated with event");
            }
            // If in single-recorder mode then just default to the first one available
            else
            {
                recorder = recorders[0];
            }
            
            if (ko.isObservable(options.recorder))
            {
                options.recorder(recorder);
            }
            
            if (event)
            {
                // Keep track of recorder that this event belongs to
                parentRecorder(recorder);
                
                if (event.isReadOnly())
                {
                    isReadOnly(true);
                    determineReadOnlyReason(event);
                }

                let promise = Promise.resolve(event);
                if (event.groupID)
                {
                    eventGroupId(event.groupID);
                    promise = promise.then(() => {
                        return recorder.apiv1.scheduler.getEventGroup({
                            id: event.groupID
                        });
                    }).then((group) => {
                        return _({
                            group: group
                        }).extend(event).value();
                    });
                }

                promise.then((eventWithGroup) => {
                    _(this.wizard).each(step => {
                        if ("completed" in step)
                        {
                            step.completed(true);
                        }

                        if ("populate" in step)
                        {
                            step.populate(eventWithGroup);
                        }
                    });
                    this.show();
                    this.wizard.selectedStep(4);
                });                
            }
            else
            {
                parentRecorder(null);
                this.show();
            }
        },

        isReadOnly: isReadOnly,

        recordingEvent: {
            id: eventId,
            groupId: eventGroupId,
            title: title,
            template: template,
            tags: tags,
            dateTime: dateTime,
            duration: duration,
            assets: assets.assets,
            recur: recur,
            recurrenceEndDate: recurrenceEndDate,
            days: ko.computed(() => {
                return _(days).toPairs().map((pair, i) => {
                    return [i, { day: pair[0], selected: pair[1]() }];
                }).filter(pair => pair[1].selected).fromPairs().mapValues(value => value.day).value();
            }),
            externalSchedulerName: externalSchedulerName,
            externalScheduler: externalScheduler,
            externalEventUrl: externalEventUrl,
            readOnlyReason: readOnlyReason,
            mediaPackage: mediaPackage,
            errorMessage: errorMessage,
            recorder: parentRecorder,
            eventObject: eventObject,
            toArgs ()
            {
                return {
                    id: this.id(),
                    presentationTitle: this.title(),
                    template: this.template().id,
                    startTime: this.dateTime().valueOf(),
                    duration: this.duration().asMinutes(),
                    recurrenceEnd: this.recurrenceEndDate().valueOf(),
                    tags: (this.tags() || []).join(","),
                    days: _(this.days()).keys().join(","),
                    assets: this.assets()
                };
            },
            viewCompletedRecording ()
            {
                previewRecording.open(mediaPackage());
            }
        },

        reset ()
        {
            eventId("");
            eventGroupId("");
            externalSchedulerId("");
            externalSchedulerName("");
            externalEventUrl("");
            isReadOnly(false);
            readOnlyReason("");
            mediaPackage(null);
            eventObject(null);
            errorMessage("");
            this.wizard.reset();

        },

        wizard: Wizard({
            intro: intro,
            details: details,
            datetime: datetime,
            assets: assets,
            summary: summary
        }),

        deleteEvent ()
        {
            if (!this.recordingEvent.id())
            {
                return;
            }

            confirm.open(`Delete scheduled event ${this.recordingEvent.title()}?`).then(() => {
                return parentRecorder().apiv1.scheduler.deleteEvent({id: this.recordingEvent.id()}).then(retval => {
                    this.dispatchEvent({type: "eventdeleted", event: ScheduledEvent(retval)});
                    this.hide();
                }).catch(error => this.dispatchEvent({type: "error", message: error.message, error: error}));
            });
        },

        deleteRecurring ()
        {
            if (!this.recordingEvent.groupId())
            {
                return;
            }

            confirm.open(`Delete scheduled recurring event ${this.recordingEvent.title()}?`).then(() => {
                return parentRecorder().apiv1.scheduler.deleteEventGroup({id: this.recordingEvent.groupId()}).then(retval => {
                    this.dispatchEvent({type: "eventdeleted", event: ScheduledEvent(retval[0].event)});
                    this.hide();
                }).catch(error => this.dispatchEvent({type: "error", message: error.message, error: error}));
            });
        },

        // Create New Single or Recurring Event, or Update Single Event
        save ()
        {
            const recorder = this.recordingEvent.id() ? parentRecorder()
                                                      : ko.unwrap(options.recorder);
            
            // Creating a new recurring event will implicitly create all its events.
            if (this.recordingEvent.recur() && !this.recordingEvent.id())
            {
                return recorder.apiv1.scheduler.createEventGroup(this.recordingEvent.toArgs()).then(retval => {
                    this.dispatchEvent({type: "recurrencesaved", events: retval});
                    this.hide();
                }).catch(error => this.dispatchEvent({type: "error", message: error.message, error: error}));
            }

            return recorder.apiv1.scheduler[this.recordingEvent.id() ? 'updateEvent' : 'createEvent'](this.recordingEvent.toArgs()).then(retval => {
                this.dispatchEvent({type: "eventsaved", event: ScheduledEvent(retval)});
                this.hide();
            }).catch(error => this.dispatchEvent({type: "error", message: error.message, error: error}));
        },

        // Update Recurring Event
        saveRecurring ()
        {
            // Updating an existing recurring event will cause its child events to be changed accordingly.
            let args = this.recordingEvent.toArgs();
            args.id = this.recordingEvent.groupId();
            const recorder = args.id ? parentRecorder()
                                     : ko.unwrap(options.recorder);

            if (args.id)
            {
                args.startTime = recurrenceStartDateTime().valueOf();
            }

            return ko.unwrap(options.recorder).apiv1.scheduler.updateEventGroup(args).then(retval => {
                this.dispatchEvent({type: "recurrencesaved", events: retval});
                this.hide();
            }).catch(error => this.dispatchEvent({type: "error", message: error.message, error: error}));
        }
    }, {disableBodyScroll: false, easilyCloseable: false, reparent: true });
}

module.exports = makeDialog;
},{"./step-0-intro":3,"./step-1-details":4,"./step-2-date-time":5,"./step-3-assets":7,"./step-4-summary":8,"cattura-ui-library/src/lib/mediaPackage":"cattura-ui-library/src/lib/mediaPackage","cattura-ui-library/src/lib/scheduledEvent":"cattura-ui-library/src/lib/scheduledEvent","cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard","cattura-ui-library/src/modals/confirm":"cattura-ui-library/src/modals/confirm","knockout":"knockout","lodash":"lodash","moment":"moment"}],3:[function(require,module,exports){
const {Step} = require("cattura-ui-library/src/lib/ui/wizard");
module.exports = Step({step: 1});

},{"cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard"}],4:[function(require,module,exports){
const _ = require("lodash");

const {Step} = require("cattura-ui-library/src/lib/ui/wizard");
const ko = require("knockout");

function makeStep (options)
{
    const templates = ko.computed(() => {
         const recorder = ko.unwrap(options.recorder) || {};
         return ko.unwrap(recorder.templates) || [];
    });
    
    let title = ko.observable();
    let template = ko.observable();
    let appendDateToTitle = ko.observable();
    let tags = ko.observableArray();

    function reset ()
    {
        title("");
        template(null);
        appendDateToTitle(false);
        tags([]);
    }

    function populate (event)
    {
        title(event.title);
        template(_(templates()).find(template => template.id === event.template));
        tags(event.tags);
    }

    function complete ()
    {
        return title() !== "" && template();
    }

    return Step({
        step: 2,
        title: title,
        recorder: options.recorder,
        recorders: options.recorders,
        template: template,
        templates: templates,
        appendDateToTitle: appendDateToTitle,
        tags: tags,
        populate: populate,
        reset: reset,
        complete: complete
    });    
}

module.exports = makeStep;
},{"cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard","knockout":"knockout","lodash":"lodash"}],5:[function(require,module,exports){
const _ = require("lodash");
const {Step} = require("cattura-ui-library/src/lib/ui/wizard");
const ko = require("knockout");
const moment = require("moment");

const DATE_FORMAT = "YYYY-MM-DD";
const TIME_FORMAT = "hh:mm A";

function makeStep (options)
{
    const momentGenerator = options.momentGenerator || moment;
    
    function dateTimeObservable (date, time)
    {
        return ko.computed({
            read ()
            {
                const dateMoment = momentGenerator(date(), DATE_FORMAT);
                const timeMoment = momentGenerator(time(), TIME_FORMAT);

                return dateMoment.set({
                    hour: timeMoment.hour(),
                    minute: timeMoment.minute(),
                    second: timeMoment.second()
                });
            },
            write (value)
            {
                value = momentGenerator(value);
                date(value.format(DATE_FORMAT));
                time(value.format(TIME_FORMAT));
            }
        });
    }    
    
    let date = ko.observable();
    let time = ko.observable();
    const dateTime = dateTimeObservable(date, time);

    let duration = ko.observable(moment.duration(0, "hours"));
    let textDuration = ko.computed({
        read ()
        {
            return duration().format("hh:mm", { trim: false });
        },
        write (value)
        {
            duration(moment.duration(value));
        }
    }).extend({notify: "always"});

    let recur = ko.observable(false);
    let recurrenceStartDate = ko.observable(); // Only required for existing recurrences. New recurrences start at the recording's date
    let recurrenceEndDate = ko.observable();

    const recurrenceStartDateTime = dateTimeObservable(recurrenceStartDate, time);

    let days = {
        monday:    ko.observable(false),
        tuesday:   ko.observable(false),
        wednesday: ko.observable(false),
        thursday:  ko.observable(false),
        friday:    ko.observable(false),
        saturday:  ko.observable(false),
        sunday:    ko.observable(false)
    };

    function reset ()
    {
        const now = momentGenerator().add(1, "hours").minutes(0);
        dateTime(now);
        duration(moment.duration(1, "hours"));

        recur(false);
        recurrenceStartDate(null);
        recurrenceEndDate(now.clone().add(1, "days"));
        _(days).each(flag => flag(false));
    }

    function populate (event)
    {
        dateTime(momentGenerator(event.startTime));
        duration(moment.duration(event.stopTime - event.startTime));

        if (event.group)
        {
            recur(true);
            recurrenceStartDate(momentGenerator(event.group.startTime).format(DATE_FORMAT));
            recurrenceEndDate(momentGenerator(event.group.stopTime));
            _(days).values()
                   .filter((flag, index) => _(event.group.days).includes(index))
                   .each((flag, index) => flag(true));
        }
    }

    function complete ()
    {
        if (recur() && (!recurrenceEndDate() || !_(days).find(flag => flag())))
        {
            return false;
        }

        return date() && time() && duration().asMilliseconds();
    }

    return Step({
        step: 3,
        dateTime: dateTime,
        date: date,
        time: time,
        duration: duration,
        textDuration: textDuration,

        recur: recur,
        recurrenceStartDate: recurrenceStartDate,
        recurrenceStartDateTime: recurrenceStartDateTime,
        recurrenceEndDate: recurrenceEndDate,
        days: days,

        populate: populate,
        reset: reset,
        complete: complete
    });    
}

module.exports = makeStep;
},{"cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard","knockout":"knockout","lodash":"lodash","moment":"moment"}],6:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const uuidv4 = require("uuid/v4");

const FileUploader = require("cattura-ui-library/src/lib/ui/fileUploader");
const Dialog = require("cattura-ui-library/src/lib/ui/dialog");
const selectable = require("cattura-ui-library/src/lib/ui/selectable");

const ASSET_CLASS = "com.cattura.share.processor.data_provider.elements.Asset";
const LINK_CLASS = "com.cattura.share.processor.data_provider.elements.Link";

function makeDialog (options)
{
    let assetId = ko.observable();

    let assetName = ko.observable().extend({
        required: true
    });

    let type = ko.observable("file");

    let url = ko.observable().extend({
        required: {
            onlyIf: () => type() === "link"
        }
    });
    let filePath = ko.observable().extend({
        required: {
            onlyIf: () => type() === "file"
        }
    });
    let fileName = ko.observable().extend({
        required: {
            onlyIf: () => type() === "file"
        }
    });

    const uploader = ko.computed(() => FileUploader({
        endpoint: (ko.unwrap(options.recorder) || {}).basePath + "api/1/upload/files/assets"
    }));

    return Dialog({
        id: assetId,

        fields: ko.validatedObservable({
            name: assetName,
            type: type,
            url: url,
            path: filePath,
            fileAlias: fileName
        }),

        open (asset)
        {
            this.reset();

            if (asset && "@class" in asset)
            {
                this.id(asset.id);
                this.fields().name(asset.name);
                this.fields().url(asset.url);
                this.fields().path(asset.path);
                this.fields().fileAlias(asset.fileAlias);

                if (asset["@class"] === ASSET_CLASS)
                {
                    this.fields().type("asset");
                }
                else
                {
                    this.fields().type("link");
                }
            }

            this.show();
        },

        reset ()
        {
            this.id("");
            this.fields().name("");
            this.fields().type("file");
            this.fields().url("");
            this.fields().path("");
            this.fields().fileAlias("");
        },

        uploadFile ()
        {
            uploader().fileChooser().then(result => {
                this.fields().fileAlias(result.file.name);
                this.fields().path(result.file.path);
            });
        },

        save ()
        {
            if (!this.fields.isValid())
            {
                this.dispatchEvent({type: "error", message: "Form is not valid."});
                return;
            }

            let asset = {
                id: this.id() || `speaker:${uuidv4()}`,
                name: this.fields().name()
            };

            if (this.fields().type() === "file")
            {
                _(asset).extend({
                    "@class": ASSET_CLASS,
                    mimeType: "application/x-octet-stream",
                    path: this.fields().path(),
                    fileAlias: this.fields().fileAlias()
                }).value();
            }
            else
            {
                _(asset).extend({
                    "@class": LINK_CLASS,
                    title: this.fields().name(),
                    url: this.fields().url()
                }).value();
            }

            this.dispatchEvent({type: "assetsaved", asset: asset});
            this.hide();
        }
    });    
}

module.exports = makeDialog;

},{"cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","cattura-ui-library/src/lib/ui/fileUploader":"cattura-ui-library/src/lib/ui/fileUploader","cattura-ui-library/src/lib/ui/selectable":"cattura-ui-library/src/lib/ui/selectable","knockout":"knockout","lodash":"lodash","uuid/v4":undefined}],7:[function(require,module,exports){
const ko = require("knockout");
const _ = require("lodash");
const toastr = require("toastr");

const {Step} = require("cattura-ui-library/src/lib/ui/wizard");
const ContextMenu = require("cattura-ui-library/src/lib/ui/contextMenu");
const selectable = require("cattura-ui-library/src/lib/ui/selectable");

/* jshint -W079 */
const confirm = require("cattura-ui-library/src/modals/confirm");

function makeStep (options)
{
    const addEditAsset = require("./add-edit-asset")(options);
    addEditAsset.addEventListener("assetsaved", event => {
        let newAsset = selectable.makeSelectable(extendAsset(event.asset));
        let newAssets = _(assets()).map(asset => {
            if (newAsset && asset.id === newAsset.id)
            {
                asset = newAsset;
                newAsset = null;
            }

            return asset;
        }).value();

        if (newAsset)
        {
            newAssets.push(newAsset);
        }

        assets(newAssets);
        toastr.success(`Asset "${event.asset.name}" saved successfully.`);
    });

    let assets = selectable.selectableObservableArray();

    function extendAsset (asset)
    {
        asset.shortType = () => asset["@class"].substring(asset["@class"].lastIndexOf(".") + 1);
        asset.downloadLink = () => "api/1/upload/" + (asset.url || asset.path);
        return asset;
    }

    function reset ()
    {
        assets([]);
    }

    function populate (event)
    {
        assets(_(event.assets).chain().cloneDeep().map(selectable.makeSelectable).map(extendAsset).value());
    }

    function complete ()
    {
        return true;
    }

    const actions = ContextMenu({
        edit (asset)
        {
            addEditAsset.open(asset);
        },

        deleteAsset (asset)
        {
            confirm.open(`Delete asset ${asset.name}?`).then(() => {
                assets(_(assets()).without(asset).value());
                toastr.success(`Asset "${asset.name}" deleted successfully.`);
            });
        }
    });

    function deleteSelected ()
    {
        assets(_(assets()).reject(asset => asset.selected()).value());
    }

    return Step({
        step: 4,
        assets: assets,
        reset: reset,
        populate: populate,
        complete: complete,
        actions: actions,
        deleteSelected: deleteSelected,
        addEditAsset: addEditAsset
    });    
}

module.exports = makeStep;
},{"./add-edit-asset":6,"cattura-ui-library/src/lib/ui/contextMenu":"cattura-ui-library/src/lib/ui/contextMenu","cattura-ui-library/src/lib/ui/selectable":"cattura-ui-library/src/lib/ui/selectable","cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard","cattura-ui-library/src/modals/confirm":"cattura-ui-library/src/modals/confirm","knockout":"knockout","lodash":"lodash","toastr":undefined}],8:[function(require,module,exports){
const ko = require("knockout");

const {Step} = require("cattura-ui-library/src/lib/ui/wizard");

function makeStep (options)
{
    const formatMoment = options.momentFormatter || (moment => moment.toString());
    const dateTime     = options.dateTime;
    
    const dateTimeFormatted = ko.computed(() => {
        const dateTimeUnwrapped = dateTime();
        if (!dateTimeUnwrapped)
        {
            return "";
        }

        return formatMoment(dateTimeUnwrapped);
    });

    return Step({
        step: 5,
        dateTimeFormatted: dateTimeFormatted
    });
}

module.exports = makeStep;


},{"cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard","knockout":"knockout"}],9:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"side-panel settings-add-edit-exclusion\" data-bind=\"dialog: $root\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"body\"\u003E";

pug_html = pug_html + "\n    \u003Ch1 data-bind=\"text: id() ? 'Edit Blackout Date' : 'Add Blackout Date'\"\u003E";

pug_html = pug_html + "Add Blackout Date\u003C\u002Fh1\u003E";

pug_html = pug_html + "\n    \u003Cdiv data-bind=\"with: fields\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Label\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cinput type=\"text\" data-bind=\"value: label\"\u002F\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Start Date\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cinput type=\"date\" data-bind=\"date: startDate\"\u002F\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "End Date\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cinput type=\"date\" data-bind=\"date: endDate\"\u002F\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Repeat\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cselect data-bind=\"value: repeat\"\u003E";

pug_html = pug_html + "\n          \u003Coption value=\"\"\u003E";

pug_html = pug_html + "No\u003C\u002Foption\u003E";

pug_html = pug_html + "\n          \u003Coption value=\"WEEKLY\"\u003E";

pug_html = pug_html + "Weekly\u003C\u002Foption\u003E";

pug_html = pug_html + "\n          \u003Coption value=\"MONTHLY\"\u003E";

pug_html = pug_html + "Monthly\u003C\u002Foption\u003E";

pug_html = pug_html + "\n          \u003Coption value=\"YEARLY\"\u003E";

pug_html = pug_html + "Yearly\u003C\u002Foption\u003E\n        \u003C\u002Fselect\u003E\n      \u003C\u002Fdiv\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"buttons\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"cancel-button\" data-bind=\"click: hide\"\u003E";

pug_html = pug_html + "Cancel\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"save-button\" data-bind=\"click: save\"\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"left-arrow\"\u003E";

pug_html = pug_html + "\n    \u003Cbutton class=\"icon-dialog-left-arrow\" data-bind=\"click: $data.hide || (() =&gt; {})\"\u003E\u003C\u002Fbutton\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],10:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const moment = require("moment");

const Dialog = require("cattura-ui-library/src/lib/ui/dialog");
const selectable = require("cattura-ui-library/src/lib/ui/selectable");

const Exclusion = require("../../tab/exclusion.js");

const {makeMoment} = require("./time");

let exclusionId = ko.observable();
let label = ko.observable();
let startDate = ko.observable().extend({
    required: true
});
let endDate = ko.observable();
let repeat = ko.observable();

/*
 * Recurrence start/end dates in the UI are at midnight UTC, since the moment-recur
 * library seems to depend on that (it fails or hangs outright if they aren't).
 * However, we don't want to submit a midnight-UTC date to the backend, because it will
 * be interpreted under the system timezone and may result in an incorrect date.
 * To get around this, we instead create a new moment under the system timezone
 * and set the correct date on it.
 *
 * moment-timezone is buggy in general, see https://github.com/c-trimm/moment-recur/issues/85
 */
function makeDateMoment (date)
{
    return makeMoment().set({
        date: date.date(),
        month: date.month(),
        year: date.year()
    });
}

function makeDialog (plugin)
{
    return Dialog({
        id: exclusionId,

        fields: ko.validatedObservable({
            label: label,
            startDate: startDate,
            endDate: endDate,
            repeat: repeat,
        }),

        open (exclusion)
        {
            this.reset();

            if (exclusion instanceof Exclusion)
            {
                this.id(exclusion.id);
                this.fields().label(exclusion.label);
                this.fields().startDate(makeDateMoment(exclusion.startDate));

                if (exclusion.startDate.valueOf() != exclusion.endDate.valueOf())
                {
                    this.fields().endDate(makeDateMoment(exclusion.endDate));
                }

                this.fields().repeat(exclusion.recurrence ? exclusion.recurrence.frequency : "");
            }

            this.show();
        },

        reset ()
        {
            this.id(null);
            this.fields().label("");
            this.fields().startDate(moment());
            this.fields().endDate("mm/dd/yyyy");
            this.fields().repeat("");
        },

        save ()
        {
            if (!this.fields.isValid())
            {
                this.dispatchEvent({type: "error", message: "Form is not valid."});
                return;
            }

            let args = {
                label: this.fields().label() || "",
                startDate: this.fields().startDate().valueOf(),
                endDate: this.fields().startDate().valueOf()
            };

            if (this.fields().endDate() && !isNaN(this.fields().endDate().valueOf()))
            {
                args.endDate = this.fields().endDate().valueOf();
            }

            if (this.fields().repeat())
            {
                args.recurrence = `FREQ=${this.fields().repeat()}`;
            }

            let request;
            if (this.id())
            {
                request = plugin.services.updateExclusion(_({
                    id: this.id()
                }).extend(args).value());
            }
            else
            {
                request = plugin.services.addExclusion(args);
            }

            request.then(retval => {
                this.dispatchEvent({type: "exclusionsaved", exclusion: new Exclusion(retval)});
                this.hide();
            }).catch(error => this.dispatchEvent({type: "error", message: error.message, error: error}));
        }
    }, {
        template: require("./content.pug")
    });
}

module.exports = makeDialog;

},{"../../tab/exclusion.js":20,"./content.pug":9,"./time":undefined,"cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","cattura-ui-library/src/lib/ui/selectable":"cattura-ui-library/src/lib/ui/selectable","knockout":"knockout","lodash":"lodash","moment":"moment"}],11:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"filter-bar\"\u003E";

pug_html = pug_html + "\n  \u003Ch2\u003E";

pug_html = pug_html + "Schedule Blackout Dates\u003C\u002Fh2\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"flex-stretcher\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"principal-button\" data-bind=\"click: addEditExclusion.open\"\u003E";

pug_html = pug_html + "+ Add Blackout Date\u003C\u002Fbutton\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Ctable class=\"table\" data-bind=\"visible: exclusions().length &gt; 0\"\u003E";

pug_html = pug_html + "\n  \u003Cthead\u003E";

pug_html = pug_html + "\n    \u003Ctr class=\"checkable-row\" data-bind=\"css: { 'is-checked': exclusions.areAllSelected }\"\u003E";

pug_html = pug_html + "\n      \u003Cth class=\"label\"\u003E";

pug_html = pug_html + "label\u003C\u002Fth\u003E";

pug_html = pug_html + "\n      \u003Cth class=\"start\"\u003E";

pug_html = pug_html + "start date\u003C\u002Fth\u003E";

pug_html = pug_html + "\n      \u003Cth class=\"end\"\u003E";

pug_html = pug_html + "end date\u003C\u002Fth\u003E";

pug_html = pug_html + "\n      \u003Cth class=\"repeats\"\u003E";

pug_html = pug_html + "repeats\u003C\u002Fth\u003E";

pug_html = pug_html + "\n      \u003Cth class=\"check\" data-bind=\"click: exclusions.toggleSelected\"\u003E\u003C\u002Fth\u003E\n    \u003C\u002Ftr\u003E\n  \u003C\u002Fthead\u003E";

pug_html = pug_html + "\n  \u003Ctbody data-bind=\"foreach: exclusions\"\u003E";

pug_html = pug_html + "\n    \u003Ctr class=\"checkable-row\" data-bind=\"css: { 'is-checked': false }\"\u003E";

pug_html = pug_html + "\n      \u003Ctd class=\"label\" data-bind=\"text: label\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n      \u003Ctd class=\"start\" data-bind=\"text: startDate\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n      \u003Ctd class=\"end\" data-bind=\"text: startDate.valueOf() != endDate.valueOf() ? endDate : '--'\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n      \u003Ctd class=\"repeats\" data-bind=\"text: 'recurrence' in $data ? _(recurrence.frequency).chain().lowerCase().startCase() : 'No'\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n      \u003Ctd class=\"actions icon-actions\" data-bind=\"event: { mouseover: $parent.actions.makeHandler($data) }\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n      \u003Ctd class=\"check\" data-bind=\"click: toggleSelected\"\u003E\u003C\u002Ftd\u003E\n    \u003C\u002Ftr\u003E\n  \u003C\u002Ftbody\u003E\n\u003C\u002Ftable\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"context-menu\" data-bind=\"contextMenu: actions\"\u003E";

pug_html = pug_html + "\n  \u003Cul\u003E";

pug_html = pug_html + "\n    \u003Cli class=\"item\" data-bind=\"click: edit\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"icon icon-action-edit\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan class=\"name\"\u003E";

pug_html = pug_html + "Edit\u003C\u002Fspan\u003E\n    \u003C\u002Fli\u003E";

pug_html = pug_html + "\n    \u003Cli class=\"item\" data-bind=\"click: deleteExclusion\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"icon icon-action-delete\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan class=\"name\"\u003E";

pug_html = pug_html + "Delete\u003C\u002Fspan\u003E\n    \u003C\u002Fli\u003E\n  \u003C\u002Ful\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"selection\" data-bind=\"css: { 'active': exclusions.selected().length }\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"flex\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"number-of-items\"\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: exclusions.selected().length\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n      ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan data-bind=\"text: exclusions.selected().length &gt; 1 ? 'items' : 'item'\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n      ";

pug_html = pug_html + "selected\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"flex-stretcher\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"action\" data-bind=\"click: deleteSelected\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"icon icon-action-delete\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan\u003E";

pug_html = pug_html + "Delete\u003C\u002Fspan\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],12:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const toastr = require("toastr");

const ContextMenu = require("cattura-ui-library/src/lib/ui/contextMenu");
const selectable = require("cattura-ui-library/src/lib/ui/selectable");

const Exclusion = require("../tab/exclusion.js");
const {apiv1} = require("./api");
const {makeMoment} = require("./time");

/* jshint -W079 */
const confirm = require("cattura-ui-library/src/modals/confirm");

function extendExclusion (exclusion)
{
    exclusion.startDate = makeMoment(exclusion.startDate).utc();
    exclusion.endDate = makeMoment(exclusion.endDate).utc();
    return exclusion;
}

function createBlackoutSettings (plugin)
{
    const addEditExclusion = require("./add-edit-exclusion")(plugin);
    addEditExclusion.addEventListener("exclusionsaved", event => {
        toastr.success(`Exclusion "${event.exclusion.label}" saved successfully.`);
        plugin.tab.loadExclusions();
    });
    addEditExclusion.addEventListener("error", event => toastr.error(event.message));
    
    let exclusions = selectable.selectableObservableWrapper(() => {
        return _(plugin.tab.exclusions())
            .map(Exclusion)
            .map(extendExclusion)
            .map(selectable.makeSelectable)
            .value();
    });

    function deleteSelected ()
    {
        confirm.open("Delete all selected blackout dates?").then(() => {
            return Promise.all(_(exclusions.selected()).map(exclusion => {
                return plugin.services.removeExclusion({
                    id: exclusion.id
                });
            }).value());
        }).then(() => {
            toastr.success("Blackout dates deleted successfully.");
            plugin.tab.loadExclusions();
        }).catch(error => {
            toastr.error(error.message);
        });
    }

    const actions = ContextMenu({
        edit (exclusion)
        {
            addEditExclusion.open(exclusion);
        },

        deleteExclusion (exclusion)
        {
            confirm.open(`Delete blackout date ${exclusion.label}?`).then(() => {
                return plugin.services.removeExclusion({
                    id: exclusion.id
                });
            }).then(() => {
                toastr.success(`Blackout date "${exclusion.label}" deleted successfully.`);
                plugin.tab.loadExclusions();
            }).catch(error => {
                toastr.error(error.message);
            });
        }
    });

    function load ()
    {
        plugin.tab.loadExclusions();
    }

    return {
        addEditExclusion: addEditExclusion,
        exclusions: exclusions,
        actions: actions,
        deleteSelected: deleteSelected,
        load: load,
        render: require("./content.pug")
    };    
}

module.exports = createBlackoutSettings;
},{"../tab/exclusion.js":20,"./add-edit-exclusion":10,"./api":undefined,"./content.pug":11,"./time":undefined,"cattura-ui-library/src/lib/ui/contextMenu":"cattura-ui-library/src/lib/ui/contextMenu","cattura-ui-library/src/lib/ui/selectable":"cattura-ui-library/src/lib/ui/selectable","cattura-ui-library/src/modals/confirm":"cattura-ui-library/src/modals/confirm","knockout":"knockout","lodash":"lodash","toastr":undefined}],13:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"change-duration\" data-bind=\"with: scheduledEvent\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"title\"\u003E";

pug_html = pug_html + "Time Remaining\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"duration\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"time\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"icon-clipboard-grey\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: remainingTime().format('hh:mm:ss', { forceLength: true, trim: false })\"\u003E\u003C\u002Fspan\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n    \u003Clabel\u003E";

pug_html = pug_html + "Add or subtract time\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"add-subtract-time\"\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"minus\" data-bind=\"click: () =&gt; extendBy(-extendByAmount()), disable: !(parseInt(extendByAmount()) &gt; 0) || parseInt(extendByAmount()) &gt;= remainingTime().asMinutes()\"\u003E";

pug_html = pug_html + "‒\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"duration\"\u003E";

pug_html = pug_html + "\n        \u003Cinput data-bind=\"value: extendByAmount\" type=\"number\"\u002F\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"unit\"\u003E";

pug_html = pug_html + "minutes\u003C\u002Fdiv\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"plus\" data-bind=\"click: () =&gt; extendBy(extendByAmount()), enable: parseInt(extendByAmount()) &gt; 0\"\u003E";

pug_html = pug_html + "+\u003C\u002Fbutton\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],14:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"import-calendar\" data-bind=\"dialog: $root\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"flex-wrapper\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"title\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-dialog-left-arrow return-arrow\" data-bind=\"click: hide\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Import schedule\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"url-flex\"\u003E";

pug_html = pug_html + "\n      \u003Cinput class=\"url-input\" data-bind=\"value: uri\"\u002F\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"import-from-url-button\" data-bind=\"click: importCalendarFromURI\"\u003E";

pug_html = pug_html + "Import from URL\u003C\u002Fbutton\u003E\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Chr\u002F\u003E";

pug_html = pug_html + "\n    \u003Cbutton class=\"upload-calendar\" data-bind=\"click: uploadFileAndImport\"\u003E";

pug_html = pug_html + "Upload Calendar File\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"infobox-info\" data-bind=\"css: { 'is-hidden': error() }\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-info-blue\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Enter the URL of the remote calendar file to import, or upload a file from your computer.\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"infobox-error\" data-bind=\"css: { 'is-hidden': !error() }\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-alert\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "Here we’ll have any error message!\u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"progress-bar\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"overlay is-hidden\"\u003E\u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],15:[function(require,module,exports){
const $ = require("jquery");
const _ = require("lodash");
const ko = require("knockout");

const Dialog = require("cattura-ui-library/src/lib/ui/dialog");
const {Wizard, Step} = require("cattura-ui-library/src/lib/ui/wizard");
const selectable = require("cattura-ui-library/src/lib/ui/selectable");
const FileUploader = require("cattura-ui-library/src/lib/ui/fileUploader");

const MediaPackage = require("cattura-ui-library/src/lib/mediaPackage");
const {apiv1} = require("./api");

const template = require("./content.pug");

let uri = ko.observable();
let error = ko.observable();

const uploader = FileUploader({
    endpoint: "/api/1/upload/files/calendar"
});

function clear ()
{
    uri("");
    error(null);
}

let resolver = null;

function makeDialog (plugin)
{
    const submitEvents = require("./submit-events")(plugin);
    
    function importCalendar (calendarUri)
    {
        return plugin.services.parseCalendarFile({
            calendarFile: calendarUri
        }).then(result => {
            dialog.hide();
            return submitEvents.open(result).then(events => {
                dialog.dispatchEvent({type: "calendarimported", events: events});
                return events;
            });
        }).then(events => {
            if (resolver)
            {
                return resolver(events);
            }
            
            return events;
        });
    }

    function importCalendarFromURI ()
    {
        const calendarUri = uri();
        if (!calendarUri)
        {
            return;
        }

        return importCalendar(calendarUri);
    }

    function uploadFileAndImport ()
    {
        return uploader.fileChooser().then(result => {
            return importCalendar(result.file.path);
        });
    }

    const dialog = Dialog({
        open: function open ()
        {
            clear();
            this.show();
            $('.import-recs-url-input').focus();
            return new Promise((resolve, reject) => resolver = resolve);
        },

        uri: uri,
        importCalendarFromURI: importCalendarFromURI,
        uploadFileAndImport: uploadFileAndImport,
        error: error,

        submitEvents: submitEvents
    }, {
        template: template
    });
    
    return dialog;
}

module.exports = makeDialog;

},{"./api":undefined,"./content.pug":14,"./submit-events":17,"cattura-ui-library/src/lib/mediaPackage":"cattura-ui-library/src/lib/mediaPackage","cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","cattura-ui-library/src/lib/ui/fileUploader":"cattura-ui-library/src/lib/ui/fileUploader","cattura-ui-library/src/lib/ui/selectable":"cattura-ui-library/src/lib/ui/selectable","cattura-ui-library/src/lib/ui/wizard":"cattura-ui-library/src/lib/ui/wizard","jquery":"jquery","knockout":"knockout","lodash":"lodash"}],16:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"modal-dialog import-calendar-submit\" data-bind=\"dialog: $root\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"close icon-close\" data-bind=\"click: hide\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Ch1\u003E";

pug_html = pug_html + "Submit Imported Events\u003C\u002Fh1\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"unbatched\"\u003E";

pug_html = pug_html + "\n    \u003Cul class=\"recordings\" data-bind=\"foreach: importedEvents\"\u003E";

pug_html = pug_html + "\n      \u003Cli class=\"recording\" data-bind=\"css: { 'is-checked': selected, disabled: !canBeSubmitted(), 'is-hidden': batched }, click: toggleSelected\"\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"duration\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"dshb-upcap-duration-text\" data-bind=\"text: event.duration.format('hh:mm')\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"info\"\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"name\"\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: event.title, css: { 'is-hidden': isEditing }\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "\n            \u003Cinput data-bind=\"textInput: event.title, css: { 'is-hidden': !isEditing() }, enterkey: () =&gt; isEditing(false)\"\u002F\u003E";

pug_html = pug_html + "\u003Cspan class=\"edit-icon material-icons\" data-bind=\"click: () =&gt; isEditing(!isEditing()), css: { 'is-hidden': isEditing }\"\u003E";

pug_html = pug_html + "edit\u003C\u002Fspan\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"date\" data-bind=\"text: new Date(event.startTime)\"\u003E\u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"check\"\u003E\u003C\u002Fdiv\u003E\n      \u003C\u002Fli\u003E\n    \u003C\u002Ful\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"batching\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"current-batch\"\u003E";

pug_html = pug_html + "\n      \u003Ch2\u003E";

pug_html = pug_html + "Current Batch\u003C\u002Fh2\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "CaptureCast Template\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"dropdown\"\u003E";

pug_html = pug_html + "\n          \u003Cselect data-bind=\"value: template, options: templates, optionsText: 'title'\"\u003E\u003C\u002Fselect\u003E\n        \u003C\u002Fdiv\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Events\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cul class=\"events\" data-bind=\"foreach: importedEvents.selected\"\u003E";

pug_html = pug_html + "\n          \u003Cli class=\"event\"\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: event.title\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fli\u003E\n        \u003C\u002Ful\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cbutton data-bind=\"click: submitBatch, enable: importedEvents.selected().length &gt; 0\"\u003E";

pug_html = pug_html + "Submit Batch\u003C\u002Fbutton\u003E\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Ch2\u003E";

pug_html = pug_html + "Batches\u003C\u002Fh2\u003E";

pug_html = pug_html + "\n    \u003Cul class=\"batches\" data-bind=\"foreach: batches\"\u003E";

pug_html = pug_html + "\n      \u003Cli class=\"batch\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-close\" data-bind=\"click: () =&gt; $parent.removeBatch($data)\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n          \u003Clabel\u003E";

pug_html = pug_html + "CaptureCast Template\u003C\u002Flabel\u003E";

pug_html = pug_html + "\u003Cspan class=\"value\" data-bind=\"text: template.title\"\u003E\u003C\u002Fspan\u003E\n        \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n        \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n          \u003Clabel\u003E";

pug_html = pug_html + "Events\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n          \u003Cul class=\"events\" data-bind=\"foreach: events\"\u003E";

pug_html = pug_html + "\n            \u003Cli class=\"event\"\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: event.title\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fli\u003E\n          \u003C\u002Ful\u003E\n        \u003C\u002Fdiv\u003E\n      \u003C\u002Fli\u003E\n    \u003C\u002Ful\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"buttons\"\u003E";

pug_html = pug_html + "\n    \u003Cbutton class=\"import-button\" data-bind=\"click: importAllBatches, enable: batches().length &gt; 0, text: `Import ${allImportableEvents().length} Events`\"\u003E\u003C\u002Fbutton\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],17:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const Dialog = require("cattura-ui-library/src/lib/ui/dialog");
const selectable = require("cattura-ui-library/src/lib/ui/selectable");
const moment = require("moment");

const templates = require("./templates").templates;

let importedEvents = selectable.selectableObservableArray();
let batches = ko.observableArray();
let template = ko.observable();
let error = ko.observable();

const dialogTemplate = require("./content.pug");

let resolver = null;

const allImportableEvents = ko.computed(() => {
    return _(batches()).map(batch => {
        return _(batch.events).map(event => {
            return {
                event: _({}).extend(event.event).extend({
                    title: event.event.title()
                }).value(),
                task: {
                    templateID: batch.template.id
                }
            };
        }).value();
    }).flatten().value();
});

function extendScheduledEvent (event)
{
    event.isEditing = ko.observable(false);
    event.event.title = ko.observable(event.event.title);
    event.event.duration = moment.duration(event.event.stopTime - event.event.startTime);
    
    const toggle = event.toggleSelected;
    event.toggleSelected = function toggleSelected ()
    {
        if (!this.canBeSubmitted())
        {
            return;
        }
        
        toggle.call(this);
    };
    
    event.batched = ko.observable(false);
    event.canBeSubmitted = function canBeSubmitted ()
    {
        return event.event.startTime > new Date().getTime();
    };
    
    return event;
}

function clear ()
{
    importedEvents([]);
    batches([]);
    error(null);
}

function submitBatch ()
{
    batches(_(batches()).concat({
        template: template(),
        events: _(importedEvents.selected()).map(event => {
            event.selected(false);
            event.batched(true);
            return event;
        }).value()
    }).value());
}

function removeBatch (batch)
{
    _(batch.events).forEach(event => event.batched(false));
    batches(_(batches()).without(batch).value());
}

function makeDialog (plugin)
{
    function importAllBatches ()
    {
        const events = allImportableEvents();
        plugin.services.scheduleEvents({events: events}).then(retval => {
            resolver(events);
            dialog.hide();
        });
    }

    const dialog = Dialog({    
        open (events)
        {
            clear();
            importedEvents(_(events).map(selectable.makeSelectable).map(extendScheduledEvent).value());
            this.show();
            return new Promise((resolve, reject) => resolver = resolve);
        },

        error: error,
        importedEvents: importedEvents,
        batches: batches,
        template: template,
        templates: templates,
        submitBatch: submitBatch,
        removeBatch: removeBatch,
        importAllBatches: importAllBatches,
        allImportableEvents: allImportableEvents
    }, {
        template: dialogTemplate
    });
    
    return dialog;
}

module.exports = makeDialog;

},{"./content.pug":16,"./templates":undefined,"cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","cattura-ui-library/src/lib/ui/selectable":"cattura-ui-library/src/lib/ui/selectable","knockout":"knockout","lodash":"lodash","moment":"moment"}],18:[function(require,module,exports){
const $ = require("jquery");
const _ = require("lodash");
const ko = require("knockout");
const moment = require("moment");
const toastr = require("toastr");

const EVENT_SOURCE = "event-source";
const LOCAL_EVENT_SOURCE = "local";

const CHANGE_DURATION_TEMPLATE = require("./change-duration.pug");

function extendScheduledEvent (event, elapsedTime, apiv1)
{
    event.startTime = ko.observable(moment(event.startTime));
    event.stopTime = ko.observable(moment(event.stopTime));
    event.duration = ko.computed(() => moment.duration(event.stopTime().valueOf() - event.startTime().valueOf()));
    event.remainingTime = ko.computed(() => {
        return event.duration().clone().subtract(elapsedTime());
    });
    
    event.extendByAmount = ko.observable(5);
    event.extendBy = function extendBy (amount)
    {
        apiv1.scheduler.updateEvent({
            id: event.id,
            duration: event.duration().clone().add(parseInt(amount), "minutes").asMinutes()
        }).then(retval => {
            event.startTime(moment(retval.startTime));
            event.stopTime(moment(retval.stopTime));
            toastr.success("Recording duration changed successfully");
        }).catch(error => toastr.error(`Failed to change recording duration: ${error.message}`));
    };
    return event;
}

function SchedulerExtension (plugin)
{
    const importCalendarDialog = require("./import-calendar")(plugin);
    plugin.importCalendar = function importCalendar ()
    {
        return importCalendarDialog.open();
    };
    
    plugin.eventSourceName = ko.computed(() => plugin.settings()[EVENT_SOURCE] || LOCAL_EVENT_SOURCE);
    plugin.isScheduleLocal = ko.computed(() => plugin.eventSourceName() === LOCAL_EVENT_SOURCE);
    
    plugin.externalSchedulers = ko.computed(() => _(require("./plugins").plugins()).filter(plugin => {
        return plugin.type.toLowerCase() === "external_scheduler";
    }).value());
    
    plugin.externalEventSource = ko.computed(() => {
        const eventSourceName = plugin.eventSourceName();
        return _(plugin.externalSchedulers()).find(externalScheduler => externalScheduler.id === eventSourceName);
    });
    
    const {capturecastEventSource, uiEventSource, relativizeStoragePath, settings} = require("./environment");
    const {apiv1} = require("./api");
    
    function appendNonDuplicate (parent, child)
    {
        parent.find(`.${child.attr("class")}`).remove();
        parent.append(child);
    }
    
    uiEventSource.addEventListener("dashboard.player-area.sidebar", event => {
        let session = event.session;
        if (!(session.captureRequest && session.captureRequest.metadata.scheduled))
        {
            return;
        }
        
        appendNonDuplicate(event.element, $(CHANGE_DURATION_TEMPLATE()));
        session.scheduledEvent = ko.observable();
        
        apiv1.scheduler.getEvent({
            id: session.captureRequest.metadata.scheduledID
        }).then(scheduledEvent => {
            session.scheduledEvent(extendScheduledEvent(scheduledEvent, session.elapsedTime, apiv1));
        });
    });
    
    const {formatMoment, makeMoment} = require("./time");
    const addEditEventDialog = require("./add-edit-event")({
        momentFormatter:       formatMoment,
        momentGenerator:       makeMoment,
        relativizeStoragePath: relativizeStoragePath,
        previewRecording:      require("./manage/preview-recording"),
        recorders:             [{
            apiv1:              apiv1,
            templates:          require("./templates").templates,
            externalSchedulers: plugin.externalSchedulers
        }]
    });
    plugin.addEditEvent = function addEditEvent (event)
    {
        addEditEventDialog.open(event);
    };
    
    addEditEventDialog.addEventListener("error", event => toastr.error(event.message));
    addEditEventDialog.addEventListener("eventsaved", event => 
        toastr.success(`Event "${event.event.title}" saved successfully.`));
    addEditEventDialog.addEventListener("recurrencesaved", event => 
        toastr.success(`Recurring event "${event.events[0].title}" saved successfully.`));
    addEditEventDialog.addEventListener("eventdeleted", event => 
        toastr.success(`Event "${event.event.title}" deleted successfully.`));
        
    plugin.tab = require("./tab")({
        plugin:                 plugin,
        addEditEventDialog:     addEditEventDialog,
        capturecastEventSource: capturecastEventSource,
        apiv1:                  apiv1,
        settings:               settings,
        template:               require("./tab/content.pug")
    });
    
    plugin.blackoutSettings = require("./blackout-settings")(plugin);
    return plugin;
}

module.exports = SchedulerExtension;
},{"./add-edit-event":2,"./api":undefined,"./blackout-settings":12,"./change-duration.pug":13,"./environment":undefined,"./import-calendar":15,"./manage/preview-recording":undefined,"./plugins":undefined,"./tab":21,"./tab/content.pug":19,"./templates":undefined,"./time":undefined,"jquery":"jquery","knockout":"knockout","lodash":"lodash","moment":"moment","toastr":undefined}],19:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_attr(t,e,n,r){if(!1===e||null==e||!e&&("class"===t||"style"===t))return"";if(!0===e)return" "+(r?t:t+'="'+t+'"');var f=typeof e;return"object"!==f&&"function"!==f||"function"!=typeof e.toJSON||(e=e.toJSON()),"string"==typeof e||(e=JSON.stringify(e),n||-1===e.indexOf('"'))?(n&&(e=pug_escape(e))," "+t+'="'+e+'"'):" "+t+"='"+e.replace(/'/g,"&#39;")+"'"}
function pug_attrs(t,r){var a="";for(var s in t)if(pug_has_own_property.call(t,s)){var u=t[s];if("class"===s){u=pug_classes(u),a=pug_attr(s,u,!1,r)+a;continue}"style"===s&&(u=pug_style(u)),a+=pug_attr(s,u,!1,r)}return a}
function pug_classes(s,r){return Array.isArray(s)?pug_classes_array(s,r):s&&"object"==typeof s?pug_classes_object(s):s||""}
function pug_classes_array(r,a){for(var s,e="",u="",c=Array.isArray(a),g=0;g<r.length;g++)(s=pug_classes(r[g]))&&(c&&a[g]&&(s=pug_escape(s)),e=e+u+s,u=" ");return e}
function pug_classes_object(r){var a="",n="";for(var o in r)o&&r[o]&&pug_has_own_property.call(r,o)&&(a=a+n+o,n=" ");return a}
function pug_escape(e){var a=""+e,t=pug_match_html.exec(a);if(!t)return e;var r,c,n,s="";for(r=t.index,c=0;r<a.length;r++){switch(a.charCodeAt(r)){case 34:n="&quot;";break;case 38:n="&amp;";break;case 60:n="&lt;";break;case 62:n="&gt;";break;default:continue}c!==r&&(s+=a.substring(c,r)),c=r+1,s+=n}return c!==r?s+a.substring(c,r):s}
var pug_has_own_property=Object.prototype.hasOwnProperty;
var pug_match_html=/["&<>]/;
function pug_merge(e,r){if(1===arguments.length){for(var t=e[0],g=1;g<e.length;g++)t=pug_merge(t,e[g]);return t}for(var l in r)if("class"===l){var n=e[l]||[];e[l]=(Array.isArray(n)?n:[n]).concat(r[l]||[])}else if("style"===l){var n=pug_style(e[l]);n=n&&";"!==n[n.length-1]?n+";":n;var a=pug_style(r[l]);a=a&&";"!==a[a.length-1]?a+";":a,e[l]=n+a}else e[l]=r[l];return e}
function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}
function pug_style(r){if(!r)return"";if("object"==typeof r){var t="";for(var e in r)pug_has_own_property.call(r,e)&&(t=t+e+":"+r[e]+";");return t}return r+""}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
;var locals_for_with = (locals || {});(function (Array, Math, bind, klass, name, sidePanelClass) {var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv data-bind=\"if: addEditEvent\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv data-bind=\"if: addEditEvent &amp;&amp; addEditEvent.wizard.assets.addEditAsset\"\u003E";

sidePanelClass = 'schedule-add-edit-asset'

bind = 'dialog: addEditEvent.wizard.assets.addEditAsset'

pug_html = pug_html + "\n    \u003Cdiv" + (pug_attr("class", pug_classes(["side-panel",sidePanelClass], [false,true]), false, false)+pug_attr("data-bind", bind, true, false)) + "\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"body\"\u003E";

pug_html = pug_html + "\n        \u003Ch1 data-bind=\"text: id() ? 'Edit Asset' : 'Add Asset'\"\u003E";

pug_html = pug_html + "Add Asset\u003C\u002Fh1\u003E";

pug_html = pug_html + "\n        \u003Cdiv data-bind=\"with: fields\"\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Name\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cinput type=\"text\" data-bind=\"value: name\"\u002F\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Type\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"dropdown\"\u003E";

pug_html = pug_html + "\n              \u003Cselect data-bind=\"value: type\"\u003E";

pug_html = pug_html + "\n                \u003Coption value=\"file\"\u003E";

pug_html = pug_html + "File\u003C\u002Foption\u003E";

pug_html = pug_html + "\n                \u003Coption value=\"link\"\u003E";

pug_html = pug_html + "Link\u003C\u002Foption\u003E\n              \u003C\u002Fselect\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\" data-bind=\"visible: type() === 'file'\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Asset File\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"file\"\u003E";

pug_html = pug_html + "\n              \u003Cinput type=\"text\" readonly=\"true\" data-bind=\"value: fileAlias\"\u002F\u003E";

pug_html = pug_html + "\n              \u003Cbutton data-bind=\"click: $parent.uploadFile\"\u003E";

pug_html = pug_html + "Upload\u003C\u002Fbutton\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\" data-bind=\"visible: type() === 'link'\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Asset URL\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cinput type=\"text\" data-bind=\"value: url\"\u002F\u003E\n          \u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"buttons\"\u003E";

pug_html = pug_html + "\n        \u003Cdiv\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n        \u003Cdiv\u003E";

pug_html = pug_html + "\n          \u003Cbutton class=\"cancel-button\" data-bind=\"click: hide\"\u003E";

pug_html = pug_html + "Cancel\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n          \u003Cbutton class=\"save-button\" data-bind=\"click: save\"\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E\n        \u003C\u002Fdiv\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"left-arrow\"\u003E";

pug_html = pug_html + "\n        \u003Cbutton class=\"icon-dialog-left-arrow\" data-bind=\"click: $data.hide || (() =&gt; {})\"\u003E\u003C\u002Fbutton\u003E\n      \u003C\u002Fdiv\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_mixins["checkbox"] = pug_interp = function(bind, id){
var block = (this && this.block), attributes = (this && this.attributes) || {};

id = id || `checkbox-${bind ? Array.prototype.map.call(bind, char => char.charCodeAt(0)).reduce((a, b, i) => a + (b * (10 * i))) : ''}-${Math.random()}`.replace(".", "")

pug_html = pug_html + "\n  ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"checkbox-wrapper\"\u003E";

pug_html = pug_html + "\n    ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cinput" + (pug_attr("id", `${id}`, true, false)+" type=\"checkbox\""+pug_attr("data-bind", `${bind}`, true, false)) + "\u002F\u003E";

pug_html = pug_html + "\n    ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Clabel" + (" class=\"check\""+pug_attr("for", `${id}`, true, false)) + "\u003E\u003C\u002Flabel\u003E";

pug_indent.push('    ');
block && block();
pug_indent.pop();
pug_html = pug_html + "\n  ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fdiv\u003E";
};









































pug_html = pug_html + "\n  \u003Cdiv class=\"dialog-wrapper add-edit-event\" data-bind=\"dialog: addEditEvent, css: {\n    readonly: addEditEvent.isReadOnly(),\n    external: !!addEditEvent.recordingEvent.externalSchedulerName(),\n    recurrence: !!addEditEvent.recordingEvent.groupId(),\n    existing: !!addEditEvent.recordingEvent.id()\n}\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"dialog-with-x\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"dialog\" data-bind=\"with: wizard\"\u003E";

pug_mixins["nav-entry"] = pug_interp = function(stepNumber, stepName, stepTitle){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv" + (" class=\"dialog-nav-step\""+pug_attr("data-bind", `click: () => {
      if ("isReadOnly" in $parent && $parent.isReadOnly())
      {
          return;
      }
      
      if (isStepEditable(${stepName}))
      {
          selectedStep(${stepName});
      }
  }, css: {
      'is-step-current': selectedStep() == ${stepName},
      'is-step-reached': !("isReadOnly" in $parent && $parent.isReadOnly()) && isStepEditable(${stepName})
  }`, true, false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"dialog-nav-step-number-circle\"\u003E";

pug_html = pug_html + (pug_escape(null == (pug_interp = stepNumber) ? "" : pug_interp)) + "\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"dialog-nav-step-name\"\u003E";

pug_html = pug_html + (pug_escape(null == (pug_interp = stepTitle) ? "" : pug_interp)) + "\u003C\u002Fdiv\u003E\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fdiv\u003E";
};

pug_html = pug_html + "\n        \u003Cdiv class=\"dialog-nav\"\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-nav-header\"\u003E";

pug_html = pug_html + "4 steps to go\u003C\u002Fdiv\u003E";

pug_indent.push('          ');
pug_mixins["nav-entry"](1, "details", "Basic information");
pug_indent.pop();

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-nav-vertical-bar\"\u003E\u003C\u002Fdiv\u003E";

pug_indent.push('          ');
pug_mixins["nav-entry"](2, "datetime", "Date and Time");
pug_indent.pop();

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-nav-vertical-bar\"\u003E\u003C\u002Fdiv\u003E";

pug_indent.push('          ');
pug_mixins["nav-entry"](3, "assets", "Assets");
pug_indent.pop();

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-nav-vertical-bar\"\u003E\u003C\u002Fdiv\u003E";

pug_indent.push('          ');
pug_mixins["nav-entry"](4, "summary", "Summary");
pug_indent.pop();
pug_html = pug_html + "\n        \u003C\u002Fdiv\u003E";

pug_mixins["next-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton class=\"forward-button\" data-bind=\"click: $parent.next\"\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-right-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Next\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

pug_mixins["save-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "save-button","data-bind": "click: $parent.save"},attributes]), false)) + "\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E";
};

pug_mixins["back-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "backward-button","data-bind": "click: $parent.previous"},attributes]), false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-left-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Back\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

klass = 'step-intro'

name = 'intro'

pug_html = pug_html + "\n        \u003Cdiv" + (pug_attr("class", pug_classes(["dialog-contents",klass], [false,true]), false, false)+pug_attr("data-bind", `with: ${name}, visible: selectedStep() == ${name}`, true, false)) + "\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"illustration\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"header\"\u003E";

pug_html = pug_html + "Schedule a Recording\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"text\"\u003E\n            ";

pug_html = pug_html + "This wizard will walk you through the process of scheduling a recording.";

pug_html = pug_html + "\n            ";

pug_html = pug_html + "In order to schedule a recording, you must have already created at least";

pug_html = pug_html + "\n            ";

pug_html = pug_html + "one template containing your recording options.\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"start-button\" data-bind=\"click: $parent.next\"\u003E";

pug_html = pug_html + "\n              \u003Cdiv class=\"btn-right-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Start\n            \u003C\u002Fbutton\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-buttons\"\u003E\u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E";

pug_mixins["next-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton class=\"forward-button\" data-bind=\"click: $parent.next\"\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-right-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Next\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

pug_mixins["save-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "save-button","data-bind": "click: $parent.save"},attributes]), false)) + "\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E";
};

pug_mixins["back-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "backward-button","data-bind": "click: $parent.previous"},attributes]), false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-left-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Back\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

klass = 'step-details'

name = 'details'

pug_html = pug_html + "\n        \u003Cdiv" + (pug_attr("class", pug_classes(["dialog-contents",klass], [false,true]), false, false)+pug_attr("data-bind", `with: ${name}, visible: selectedStep() == ${name}`, true, false)) + "\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"header\"\u003E";

pug_html = pug_html + "Basic Information\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Title\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cinput type=\"text\" data-bind=\"value: title\"\u002F\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\" data-bind=\"visible: ko.unwrap(recorders).length &gt; 1\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "CaptureCast Recorder\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"dropdown\"\u003E";

pug_html = pug_html + "\n              \u003Cselect data-bind=\"value: recorder, options: recorders, optionsText: 'displayName', disable: !!$parents[1].recordingEvent.id()\"\u003E\u003C\u002Fselect\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Media Template\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"dropdown\"\u003E";

pug_html = pug_html + "\n              \u003Cselect data-bind=\"value: template, options: templates, optionsText: 'title'\"\u003E\u003C\u002Fselect\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Tags\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cinput data-bind=\"selectize: {\n            create: true,\n            items: tags\n        }\"\u002F\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Append date to title\u003C\u002Flabel\u003E";

pug_indent.push('            ');
pug_mixins["checkbox"]("checked: appendDateToTitle");
pug_indent.pop();
pug_html = pug_html + "\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-buttons\"\u003E";

pug_indent.push('            ');
pug_mixins["next-button"]();
pug_indent.pop();
pug_html = pug_html + "\n          \u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E";

pug_mixins["day-button"] = pug_interp = function(name, label){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cli" + (pug_attr("data-bind", `css: { 'selected': days['${name}'] }`, true, false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attr("data-bind", `click: () => days['${name}'](!days['${name}']())`, true, false)) + "\u003E";

pug_html = pug_html + (pug_escape(null == (pug_interp = label) ? "" : pug_interp)) + "\u003C\u002Fbutton\u003E\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fli\u003E";
};

pug_mixins["next-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton class=\"forward-button\" data-bind=\"click: $parent.next\"\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-right-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Next\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

pug_mixins["save-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "save-button","data-bind": "click: $parent.save"},attributes]), false)) + "\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E";
};

pug_mixins["back-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "backward-button","data-bind": "click: $parent.previous"},attributes]), false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-left-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Back\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

klass = 'step-date-time'

name = 'datetime'

pug_html = pug_html + "\n        \u003Cdiv" + (pug_attr("class", pug_classes(["dialog-contents",klass], [false,true]), false, false)+pug_attr("data-bind", `with: ${name}, visible: selectedStep() == ${name}`, true, false)) + "\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"header\"\u003E";

pug_html = pug_html + "Date and Time\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Date\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cinput type=\"date\" data-bind=\"value: date\"\u002F\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Time\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"time-input\" data-bind=\"timePicker: { value: time }\"\u003E\u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Duration\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"time-input\" data-bind=\"durationPicker: { value: textDuration }\"\u003E\u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"control repeat\"\u003E";

pug_html = pug_html + "\n            \u003Clabel\u003E";

pug_html = pug_html + "Repeat\u003C\u002Flabel\u003E";

pug_indent.push('            ');
pug_mixins["checkbox"]("checked: recur");
pug_indent.pop();
pug_html = pug_html + "\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"recurrence\" data-bind=\"visible: recur\"\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"control\" data-bind=\"visible: recurrenceStartDate\"\u003E";

pug_html = pug_html + "\n              \u003Clabel\u003E";

pug_html = pug_html + "Repeat Start Date\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n              \u003Cinput type=\"date\" data-bind=\"value: recurrenceStartDate\"\u002F\u003E\n            \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n              \u003Clabel\u003E";

pug_html = pug_html + "Repeat End Date\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n              \u003Cinput type=\"date\" data-bind=\"date: recurrenceEndDate\"\u002F\u003E\n            \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n              \u003Clabel\u003E";

pug_html = pug_html + "Select Days\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n              \u003Cul class=\"days\"\u003E";

pug_indent.push('                ');
pug_mixins["day-button"]("sunday", "Sun");
pug_indent.pop();

pug_indent.push('                ');
pug_mixins["day-button"]("monday", "Mon");
pug_indent.pop();

pug_indent.push('                ');
pug_mixins["day-button"]("tuesday", "Tue");
pug_indent.pop();

pug_indent.push('                ');
pug_mixins["day-button"]("wednesday", "Wed");
pug_indent.pop();

pug_indent.push('                ');
pug_mixins["day-button"]("thursday", "Thu");
pug_indent.pop();

pug_indent.push('                ');
pug_mixins["day-button"]("friday", "Fri");
pug_indent.pop();

pug_indent.push('                ');
pug_mixins["day-button"]("saturday", "Sat");
pug_indent.pop();
pug_html = pug_html + "\n              \u003C\u002Ful\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-buttons\"\u003E";

pug_indent.push('            ');
pug_mixins["next-button"]();
pug_indent.pop();

pug_indent.push('            ');
pug_mixins["back-button"]();
pug_indent.pop();
pug_html = pug_html + "\n          \u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E";

pug_mixins["next-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton class=\"forward-button\" data-bind=\"click: $parent.next\"\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-right-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Next\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

pug_mixins["save-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "save-button","data-bind": "click: $parent.save"},attributes]), false)) + "\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E";
};

pug_mixins["back-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "backward-button","data-bind": "click: $parent.previous"},attributes]), false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-left-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Back\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

klass = 'step-assets'

name = 'assets'

pug_html = pug_html + "\n        \u003Cdiv" + (pug_attr("class", pug_classes(["dialog-contents",klass], [false,true]), false, false)+pug_attr("data-bind", `with: ${name}, visible: selectedStep() == ${name}`, true, false)) + "\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"filter-bar\"\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"header\"\u003E";

pug_html = pug_html + "Assets\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"flex-stretcher\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"principal-button\" data-bind=\"click: addEditAsset.open\"\u003E";

pug_html = pug_html + "+ Add Asset\u003C\u002Fbutton\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Ctable class=\"table\"\u003E";

pug_html = pug_html + "\n            \u003Cthead\u003E";

pug_html = pug_html + "\n              \u003Ctr class=\"checkable-row\" data-bind=\"css: { 'is-checked': assets.areAllSelected }\"\u003E";

pug_html = pug_html + "\n                \u003Cth class=\"name\"\u003E";

pug_html = pug_html + "name\u003C\u002Fth\u003E";

pug_html = pug_html + "\n                \u003Cth class=\"type\"\u003E";

pug_html = pug_html + "type\u003C\u002Fth\u003E";

pug_html = pug_html + "\n                \u003Cth class=\"check\" data-bind=\"click: assets.toggleSelected\"\u003E\u003C\u002Fth\u003E\n              \u003C\u002Ftr\u003E\n            \u003C\u002Fthead\u003E";

pug_html = pug_html + "\n            \u003Ctbody data-bind=\"foreach: assets\"\u003E";

pug_html = pug_html + "\n              \u003Ctr class=\"checkable-row\" data-bind=\"css: { 'is-checked': selected }\"\u003E";

pug_html = pug_html + "\n                \u003Ctd class=\"name\"\u003E";

pug_html = pug_html + "\u003Ca data-bind=\"attr: { href: downloadLink() }, text: name\"\u003E\u003C\u002Fa\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                \u003Ctd class=\"type\" data-bind=\"text: shortType()\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                \u003Ctd class=\"actions icon-actions\" data-bind=\"event: { mouseover: $parent.actions.makeHandler($data) }\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                \u003Ctd class=\"check\" data-bind=\"click: toggleSelected\"\u003E\u003C\u002Ftd\u003E\n              \u003C\u002Ftr\u003E\n            \u003C\u002Ftbody\u003E\n          \u003C\u002Ftable\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"context-menu\" data-bind=\"contextMenu: actions\"\u003E";

pug_html = pug_html + "\n            \u003Cul\u003E";

pug_html = pug_html + "\n              \u003Cli class=\"item\" data-bind=\"click: edit\"\u003E";

pug_html = pug_html + "\n                \u003Cdiv class=\"icon icon-action-edit\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan class=\"name\"\u003E";

pug_html = pug_html + "Edit\u003C\u002Fspan\u003E\n              \u003C\u002Fli\u003E";

pug_html = pug_html + "\n              \u003Cli class=\"item\" data-bind=\"click: deleteAsset\"\u003E";

pug_html = pug_html + "\n                \u003Cdiv class=\"icon icon-action-delete\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan class=\"name\"\u003E";

pug_html = pug_html + "Delete\u003C\u002Fspan\u003E\n              \u003C\u002Fli\u003E\n            \u003C\u002Ful\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"selection\" data-bind=\"css: { 'active': assets.selected().length }\"\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"flex\"\u003E";

pug_html = pug_html + "\n              \u003Cdiv class=\"number-of-items\"\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: assets.selected().length\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n                ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan data-bind=\"text: assets.selected().length &gt; 1 ? 'items' : 'item'\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n                ";

pug_html = pug_html + "selected\n              \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n              \u003Cdiv class=\"flex-stretcher\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n              \u003Cdiv class=\"action\" data-bind=\"click: deleteSelected\"\u003E";

pug_html = pug_html + "\n                \u003Cdiv class=\"icon icon-action-delete\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\u003Cspan\u003E";

pug_html = pug_html + "Delete\u003C\u002Fspan\u003E\n              \u003C\u002Fdiv\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-buttons\"\u003E";

pug_indent.push('            ');
pug_mixins["next-button"]();
pug_indent.pop();

pug_indent.push('            ');
pug_mixins["back-button"]();
pug_indent.pop();
pug_html = pug_html + "\n          \u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E";

pug_mixins["next-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton class=\"forward-button\" data-bind=\"click: $parent.next\"\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-right-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Next\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

pug_mixins["save-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "save-button","data-bind": "click: $parent.save"},attributes]), false)) + "\u003E";

pug_html = pug_html + "Save\u003C\u002Fbutton\u003E";
};

pug_mixins["back-button"] = pug_interp = function(){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cbutton" + (pug_attrs(pug_merge([{"class": "backward-button","data-bind": "click: $parent.previous"},attributes]), false)) + "\u003E";

pug_html = pug_html + "\n          ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv class=\"btn-left-arrow\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "Back\n        ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fbutton\u003E";
};

klass = 'step-summary'

name = 'summary'

pug_html = pug_html + "\n        \u003Cdiv" + (pug_attr("class", pug_classes(["dialog-contents",klass], [false,true]), false, false)+pug_attr("data-bind", `with: ${name}, visible: selectedStep() == ${name}`, true, false)) + "\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"header\"\u003E";

pug_html = pug_html + "Summary\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"readonly-message\" data-bind=\"visible: $parents[1].isReadOnly, with: $parents[1].recordingEvent\"\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox-info\" data-bind=\"visible: readOnlyReason() == 'complete'\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-info-blue\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "This event has already been recorded.";

pug_html = pug_html + "\n              ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Ca href=\"#\" data-bind=\"visible: mediaPackage() != null, click: viewCompletedRecording\"\u003E";

pug_html = pug_html + "View the recording\u003C\u002Fa\u003E\n            \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox-info\" data-bind=\"visible: readOnlyReason() == 'external'\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-info-blue\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "This event is synced from an external scheduler and is not editable on CaptureCast.";

pug_html = pug_html + "\n              ";

pug_html = pug_html + " ";

pug_html = pug_html + "\u003Ca data-bind=\"visible: externalEventUrl() != '', attr: { href: externalEventUrl() }\"\u003E\n                ";

pug_html = pug_html + "View the event on";

pug_html = pug_html + "\n                ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan data-bind=\"text: externalSchedulerName\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fa\u003E\n            \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox-error\" data-bind=\"visible: readOnlyReason() == 'failedToStart'\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-alert\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "\u003Cspan\u003E";

pug_html = pug_html + "This event failed to start recording.\u003C\u002Fspan\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox-error\" data-bind=\"visible: readOnlyReason() == 'error'\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-alert\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: errorMessage\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox-info\" data-bind=\"visible: readOnlyReason() == 'unknown'\"\u003E";

pug_html = pug_html + "\u003Cspan class=\"icon-info-blue\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "This event is not editable.\u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"div\" data-bind=\"with: $parents[1].recordingEvent\"\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox\"\u003E";

pug_html = pug_html + "\n              \u003Ch3\u003E";

pug_html = pug_html + "\n                \u003Cdiv\u003E";

pug_html = pug_html + "Recording Info\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n                \u003Cdiv class=\"icon-edit\" data-bind=\"visible: !$parents[2].isReadOnly(), click: () =&gt; $parents[1].selectedStep($parents[1].details)\"\u003E\u003C\u002Fdiv\u003E\n              \u003C\u002Fh3\u003E";

pug_html = pug_html + "\n              \u003Ctable\u003E";

pug_html = pug_html + "\n                \u003Ccolgroup\u003E";

pug_html = pug_html + "\n                  \u003Ccol class=\"labels-column\"\u002F\u003E\n                \u003C\u002Fcolgroup\u003E";

pug_html = pug_html + "\n                \u003Ctr\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"label\"\u003E";

pug_html = pug_html + "Name:\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"value\" data-bind=\"text: title\"\u003E\u003C\u002Ftd\u003E\n                \u003C\u002Ftr\u003E";

pug_html = pug_html + "\n                \u003Ctr data-bind=\"if: template\"\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"label\"\u003E";

pug_html = pug_html + "Template:\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"value\" data-bind=\"text: template().title\"\u003E\u003C\u002Ftd\u003E\n                \u003C\u002Ftr\u003E";

pug_html = pug_html + "\n                \u003Ctr\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"label\"\u003E";

pug_html = pug_html + "Tags:\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"value\"\u003E";

pug_html = pug_html + "\n                    \u003Cul data-bind=\"foreach: tags\"\u003E";

pug_html = pug_html + "\n                      \u003Cli data-bind=\"text: $data\"\u003E\u003C\u002Fli\u003E\n                    \u003C\u002Ful\u003E\n                  \u003C\u002Ftd\u003E\n                \u003C\u002Ftr\u003E\n              \u003C\u002Ftable\u003E\n            \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"infobox\"\u003E";

pug_html = pug_html + "\n              \u003Ch3\u003E";

pug_html = pug_html + "\n                \u003Cdiv\u003E";

pug_html = pug_html + "Date and Time\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n                \u003Cdiv class=\"icon-edit\" data-bind=\"visible: !$parents[2].isReadOnly(), click: () =&gt; $parents[1].selectedStep($parents[1].datetime)\"\u003E\u003C\u002Fdiv\u003E\n              \u003C\u002Fh3\u003E";

pug_html = pug_html + "\n              \u003Ctable\u003E";

pug_html = pug_html + "\n                \u003Ccolgroup\u003E";

pug_html = pug_html + "\n                  \u003Ccol class=\"labels-column\"\u002F\u003E\n                \u003C\u002Fcolgroup\u003E";

pug_html = pug_html + "\n                \u003Ctr\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"label\"\u003E";

pug_html = pug_html + "Date and Time:\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"value\" data-bind=\"text: $parent.dateTimeFormatted\"\u003E\u003C\u002Ftd\u003E\n                \u003C\u002Ftr\u003E";

pug_html = pug_html + "\n                \u003Ctr\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"label\"\u003E";

pug_html = pug_html + "Duration:\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"value\" data-bind=\"text: duration().format('hh:mm', { trim: false })\"\u003E\u003C\u002Ftd\u003E\n                \u003C\u002Ftr\u003E";

pug_html = pug_html + "\n                \u003Ctr data-bind=\"visible: recur\"\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"label\"\u003E";

pug_html = pug_html + "Repeats:\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n                  \u003Ctd class=\"value\"\u003E\n                    ";

pug_html = pug_html + "Every";

pug_html = pug_html + "\n                    ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan data-bind=\"text: _(days()).values().map(_.startCase).join(', ')\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n                    ";

pug_html = pug_html + "until";

pug_html = pug_html + "\n                    ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan data-bind=\"text: recurrenceEndDate\"\u003E\u003C\u002Fspan\u003E\n                  \u003C\u002Ftd\u003E\n                \u003C\u002Ftr\u003E\n              \u003C\u002Ftable\u003E\n            \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n            \u003Cdiv class=\"div\" data-bind=\"if: externalScheduler\"\u003E";

pug_html = pug_html + "\n              \u003Cdiv class=\"infobox\" data-bind=\"visible: externalScheduler().eventDataTemplate, if: externalScheduler().eventDataTemplate\"\u003E";

pug_html = pug_html + "\n                \u003Ch3\u003E";

pug_html = pug_html + "\n                  \u003Cdiv\u003E";

pug_html = pug_html + "External Event Info\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n                  \u003Cdiv class=\"icon-edit\" data-bind=\"visible: externalEventUrl, click: () =&gt; window.open(externalEventUrl())\"\u003E\u003C\u002Fdiv\u003E\n                \u003C\u002Fh3\u003E";

pug_html = pug_html + "\n                \u003Cdiv data-bind=\"htmlWithBindings: () =&gt; externalScheduler().eventDataTemplate($data)\"\u003E\u003C\u002Fdiv\u003E\n              \u003C\u002Fdiv\u003E\n            \u003C\u002Fdiv\u003E\n          \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n          \u003Cdiv class=\"dialog-buttons\"\u003E";

pug_html = pug_html + "\n            \u003C!-- ko if: $parents[1].recordingEvent.groupId--\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"save-button forward-button\" data-bind=\"click: $parents[1].save\"\u003E";

pug_html = pug_html + "Save Single\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"save-button forward-button\" data-bind=\"click: $parents[1].saveRecurring\"\u003E";

pug_html = pug_html + "Save Recurrence\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n            \u003C!-- \u002Fko--\u003E";

pug_html = pug_html + "\n            \u003C!-- ko ifnot: $parents[1].recordingEvent.groupId--\u003E";

pug_indent.push('            ');
pug_mixins["save-button"].call({
attributes: {"class": "forward-button","data-bind": "click: $parents[1].save"}
});
pug_indent.pop();

pug_html = pug_html + "\n            \u003C!-- \u002Fko--\u003E";

pug_indent.push('            ');
pug_mixins["back-button"]();
pug_indent.pop();

pug_html = pug_html + "\n            \u003C!-- ko if: $parents[1].recordingEvent.id() && !$parents[1].recordingEvent.externalSchedulerName()--\u003E";

pug_html = pug_html + "\n            \u003C!-- ko ifnot: $parents[1].recordingEvent.groupId--\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"delete-button forward-button\" data-bind=\"click: $parents[1].deleteEvent\"\u003E";

pug_html = pug_html + "Delete\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n            \u003C!-- \u002Fko--\u003E";

pug_html = pug_html + "\n            \u003C!-- ko if: $parents[1].recordingEvent.groupId--\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"delete-button delete-single forward-button\" data-bind=\"click: $parents[1].deleteEvent\"\u003E";

pug_html = pug_html + "Delete Single\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n            \u003Cbutton class=\"delete-button delete-recurrence forward-button\" data-bind=\"click: $parents[1].deleteRecurring\"\u003E";

pug_html = pug_html + "Delete Recurrence\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n            \u003C!-- \u002Fko--\u003E";

pug_html = pug_html + "\n            \u003C!-- \u002Fko--\u003E\n          \u003C\u002Fdiv\u003E\n        \u003C\u002Fdiv\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"dialog-close-x icon-close-white\" data-bind=\"click: hide\"\u003E\u003C\u002Fdiv\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"schedule-view\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"filter-bar\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"flex-stretcher\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv data-bind=\"visible: plugin.isScheduleLocal\"\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"principal-button\" data-bind=\"visible: importCalendar, click: importCalendar\"\u003E";

pug_html = pug_html + "Import calendar\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"principal-button\" data-bind=\"visible: addEditEvent, click: addEditEvent.open\"\u003E";

pug_html = pug_html + "+ Schedule recording\u003C\u002Fbutton\u003E\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv data-bind=\"with: plugin.externalEventSource\"\u003E";

pug_html = pug_html + "\n      \u003Cbutton class=\"principal-button\" data-bind=\"visible: 'refresh' in $data, click: refresh\"\u003E";

pug_html = pug_html + "Reload Schedule\u003C\u002Fbutton\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv data-bind=\"fullcalendar: calendar\"\u003E\u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";}.call(this,"Array" in locals_for_with?locals_for_with.Array:typeof Array!=="undefined"?Array:undefined,"Math" in locals_for_with?locals_for_with.Math:typeof Math!=="undefined"?Math:undefined,"bind" in locals_for_with?locals_for_with.bind:typeof bind!=="undefined"?bind:undefined,"klass" in locals_for_with?locals_for_with.klass:typeof klass!=="undefined"?klass:undefined,"name" in locals_for_with?locals_for_with.name:typeof name!=="undefined"?name:undefined,"sidePanelClass" in locals_for_with?locals_for_with.sidePanelClass:typeof sidePanelClass!=="undefined"?sidePanelClass:undefined));return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],20:[function(require,module,exports){
const _ = require("lodash");
const moment = require("moment");
//require("moment-recur");

/*
 * Exclusions in the UI use UTC moments, because moment-recur won't work with
 * anything else.
 * See https://github.com/c-trimm/moment-recur/issues/85 for other issues with
 * moment-recur.
 */
function localDateToMoment (localDate)
{
    return moment.utc({
        day: localDate.dayOfMonth,
        month: localDate.monthValue - 1,
        year: localDate.year
    });
}

function compareDateRange (startDate, dateToCompare, endDate)
{
    endDate = endDate || startDate;
    return dateToCompare.isSame(startDate, "day") ||
        (dateToCompare.isAfter(startDate, "day") && dateToCompare.isBefore(endDate, "day")) ||
        dateToCompare.isSame(endDate, "day");
}

function createRecurrence (recurrence, startDate)
{
    var unit = "days";
    var interval = 1;

    if (!recurrence)
    {
        return null;
    }

    interval = recurrence.interval || interval;

    switch (recurrence.frequency)
    {
        case "YEARLY":
            unit = "years";
            break;
        case "WEEKLY":
            unit = "weeks";
            break;
        case "MONTHLY":
            unit = "months";
            break;
    }

    return moment(startDate).recur().every(interval, unit);
}

function getSubExclusionForDate (exclusion, date)
{
    var startDate = exclusion.startDate;
    var endDate = exclusion.endDate || exclusion.startDate;
    var startRecurrence = createRecurrence(exclusion.recurrence, startDate);
    var endRecurrence = createRecurrence(exclusion.recurrence, endDate);
    var diff = endDate.diff(startDate, "days");

    date = moment(date).subtract(1, "days");
    return new Exclusion({
        startDate: startRecurrence.fromDate(moment(date).subtract(diff, "days")).next(1)[0],
        endDate: endRecurrence.fromDate(date).next(1)[0]
    });
}

function makeMomentFromDate (date)
{
    if (typeof date === "object")
    {
        if ("monthValue" in date)
        {
            return localDateToMoment(date);
        }
        else if (date instanceof Array && date.length === 3)
        {
            return localDateToMoment({
                dayOfMonth: date[2],
                monthValue: date[1],
                year: date[0]
            });
        }
    }
    
    return moment(date);
}

function Exclusion (data)
{
    if (!(this instanceof Exclusion))
    {
        return new Exclusion(data);
    }

    _(this).extend(data).value();
    this.startDate = makeMomentFromDate(this.startDate);

    if (this.endDate)
    {
        this.endDate = makeMomentFromDate(this.endDate);
    }

    this.matches = function matches (date)
    {
        date = moment.utc(date);

        /*
         * 28 July 2016: If this date is before exclusion start, don't bother
         * checking any further. This is because moment-recur will generate
         * recurring dates before the specified start time (whereas the library
         * we are using on the recorder does not) so falling back to the recurrence
         * can produce false positives.
         */
        if (date.isBefore(this.startDate, "day"))
        {
            return false;
        }

        if (compareDateRange(this.startDate, date, this.endDate))
        {
            return true;
        }

        if (this.recurrence)
        {
            return getSubExclusionForDate(this, date).matches(date);
        }

        return false;
    };
}

module.exports = Exclusion;

},{"lodash":"lodash","moment":"moment"}],21:[function(require,module,exports){
const _ = require("lodash");
const $ = require("jquery");
const ko = require("knockout");
const moment = require("moment");
const toastr = require("toastr");

const Calendar = require("cattura-ui-library/src/lib/ui/calendar");
const ScheduledEvent = require("cattura-ui-library/src/lib/scheduledEvent");
const Exclusion = require("./exclusion");

function makeTab (options)
{
    const plugin                 = options.plugin;
    const addEditEventDialog     = options.addEditEventDialog;
    const capturecastEventSource = options.capturecastEventSource;
    const apiv1                  = options.apiv1;
    const template               = options.template;
    const settings               = options.settings;
    
    if (addEditEventDialog)
    {
        _(["eventsaved", "recurrencesaved", "eventdeleted"]).forEach(event => {
            addEditEventDialog.addEventListener(event, event => calendar.refresh());
        });
    }
    
    function importCalendar ()
    {
        return plugin.importCalendar().then(events => {
            toastr.success(`${events.length} events imported.`);
            calendar.refresh();
        });
    }

    if (capturecastEventSource)
    {
        capturecastEventSource.addEventListener("SchedulerEventSourceSyncEvent", () => calendar.refresh());
    }

    const TITLE = "Schedule";

    let exclusions = ko.observableArray();
    exclusions.subscribe(() => calendar.recolorDays());

    function eventUpdateCallback (event)
    {
        const newStartTimeMillis = adjustDateForTimezone(event.start.valueOf(), event.timezone, true);
        const newStopTimeMillis = adjustDateForTimezone(event.end.valueOf(), event.timezone, true);
        return apiv1.scheduler.updateEvent({
            id: event.id,
            startTime: newStartTimeMillis,
            duration: (newStopTimeMillis - newStartTimeMillis) / 1000 / 60
        }).then(retval => {
            toastr.success(`Event "${event.title}" saved successfully.`);
            calendar.refresh();
        }).catch(error => {
            toastr.error(error.message || `Event "${event.title}" was not saved successfully.`);
            calendar.refresh();
        });
    }

    function loadExclusions ()
    {
        if (!plugin)
        {
            return Promise.resolve([]);
        }

        return plugin.services.getExclusions().then(dates => {
            exclusions(_(dates).map(Exclusion)
                .sortBy(date => date.startDate.valueOf())
                .value()
            );
        }).catch(console.error);
    }

    let calendar = Calendar({
        timezone: (settings ? settings().timezone : null) || "local",
        header: {
            left: "month,agendaWeek,agendaDay",
            center: "title",
            right: "today prev,next"
        },

        eventDataTransform (event)
        {
            let className = [];
            if (event.status === "FAILED")
            {
                className.push("error");
            }
            else if (event.status === "FUTURE")
            {
                className.push("future");
            }
            else if (event.status === "CAPTURING")
            {
                className.push("current");
            }
            else
            {
                className.push("done");
            }

            return _({
                start: adjustDateForTimezone(event.startTime, event.timezone),
                end: adjustDateForTimezone(event.stopTime, event.timezone),
                className: className,
                editable: event.editable && className === "future"
            }).extend(event).value();
        },

        events (start, end, timezone, callback)
        {
            apiv1.scheduler.getEvents({rangeStart: start.valueOf(), rangeEnd: end.valueOf()}).then(function (events) {
                callback(_(events)
                    .map(ScheduledEvent)
                    .map(event => {
                        if (timezone && moment.tz)
                        {
                            event.timezone = moment.tz.zone(timezone);                    
                        }
                        
                        return event;
                    }).value());
            });
        },

        eventClick (event)
        {
            plugin.addEditEvent(event);
        },

        dayRender (date, cell)
        {
            $(cell).toggleClass("excluded-date", isExcluded(date));
        },

        recolorDays ()
        {
            const t = this;
            this.getElement().find(".fc-day").each(function () {
                const date = moment($(this).attr("data-date"));
                t.dayRender(date, this);
            });
        },

        eventDrop: eventUpdateCallback,
        eventResize: eventUpdateCallback
    });

    function load ()
    {
        loadExclusions();
        calendar.refresh();
    }

    function isExcluded (date)
    {
        date = moment(date);
        return !!(_(exclusions()).find(exclusion => exclusion.matches(date)));
    }

    function adjustDateForTimezone (timestamp, timezone, isAdjustingOutOfZone)
    {
        if (!timezone)
        {
            return timestamp;
        }
        
        return timestamp - ((timezone.utcOffset(timestamp) * 1000 * 60) * (isAdjustingOutOfZone ? -1 : 1));
    }

    return {
        title: TITLE,
        calendar: calendar,
        importCalendar: importCalendar,
        addEditEvent: addEditEventDialog,
        load: load,
        loadExclusions: loadExclusions,
        exclusions: exclusions,
        plugin: plugin,
        render: template
    };
}

module.exports = makeTab;
},{"./exclusion":20,"cattura-ui-library/src/lib/scheduledEvent":"cattura-ui-library/src/lib/scheduledEvent","cattura-ui-library/src/lib/ui/calendar":"cattura-ui-library/src/lib/ui/calendar","jquery":"jquery","knockout":"knockout","lodash":"lodash","moment":"moment","toastr":undefined}]},{},[18])(18)
});
